#include <allegro.h>
#include <vector.h>

typedef struct S_TileTexture
	{
		int id;
		int offset;
		BITMAP *data;
	} Tile;

class C_IsoMap
	{
	public:
		unsigned char width;
		unsigned char height;
		unsigned char adjust_x;
		unsigned	char adjust_y;
		unsigned char scr_max_x;
		unsigned char scr_max_y;
		int pos_x;
		int pos_y;

		unsigned char mapdata[256*256];
		BITMAP *out_screen;
		vector<Tile> TileList;		
	public:
		C_IsoMap();
		Add_Tile(BITMAP *bmp, int o);
		Draw_Map(BITMAP *scrto);
		Load_Data_Map(char *filename);
		Scroll(float vert, float horz);
	};

C_IsoMap::C_IsoMap()
	{
	int i,j;
	width = 64;
	height = 32;
	pos_x = 5;
	pos_y = 5;
	adjust_x = width+1;
	adjust_y = height+1;
	scr_max_x = 15;
	scr_max_y = 36;
	for(i=0;i<256;i++)
		{
		for(j=0;j<256;j++)
			{
			mapdata[i + (j * 256)] = 0;
			}
		}
	}

C_IsoMap::Add_Tile(BITMAP *bmp, int o)
	{
	Tile Temp;
	Temp.id = TileList.size() + 128;
	Temp.offset = o;
	Temp.data = create_bitmap(width,height+o);
	clear(Temp.data);
	blit(bmp,Temp.data,0,0,0,0,width,height+o);
	TileList.push_back(Temp);
	}

C_IsoMap::Draw_Map(BITMAP *scrto)
	{
	int i,j;
	int x,y;
	int k = 0;
	int o = 0;
	int ox;
	int oy;
	int f;
	int s;
	ox = adjust_x - width;
	oy = adjust_y - height;
	for(j = pos_y ,y =-1;
		 j< pos_y + scr_max_y ; 
		 j++,y++)
		{
		if (k==1) {k=0;}else{k=1;}
		f = ox + (k * (width/2));
		s = oy + (o * (height/2));
		for(i = (int) pos_x,x = -1;
			 i < (int) pos_x+ (int) scr_max_x ;
			 i++,x++)
			{
draw_sprite(
		scrto,
		TileList[(int) mapdata[i+(j*256)]].data,
	(x) * ( width ) - f,
	(y) * ( height) - s - (TileList[(int) mapdata[i+(j*256)]].offset)
		);
			}
			o++;
		}



	}

C_IsoMap::Load_Data_Map(char *filename)
	{
	FILE *fp;
	int n,i;
	long c;
	unsigned char d;

	fp = fopen(filename, "rb");
	for(i=0;i<128;i++)
		{
		d = (char)getc(fp);
		}
	c = 0;
	while (c <= 256 * 256)
		{
		d = (unsigned char) getc(fp);
		if(d>=192 && d <=255)
			{
			n = d - 192;
			d = (unsigned char) getc(fp);
			while(n-->0)
				{
				mapdata[c++] = d;
				}
			}
		else
			{
			mapdata[c++] =  d;
			}
		}
	}

C_IsoMap::Scroll(float vert, float horz)
	{	
	if(horz < 0 && pos_x >= 0)
		{	adjust_x += (char) horz; }
	if(horz > 0 && (pos_x + scr_max_x) < 256)
		{	adjust_x += (char) horz; }
	if(vert < 0 && pos_y >= 2)
		{	adjust_y += (char) vert; } 
	if(vert > 0 && (pos_y + scr_max_y) < 256)
		{	adjust_y += (char) vert; }
	if(adjust_y >= (2*height)+1)
		{
		pos_y+=2;
		adjust_y = height+1;	
		}
	else if(adjust_y <= 1)
		{
		pos_y-=2;
		adjust_y = height+1;
		}
	if(adjust_x >= (2*width) +1)
		{
		pos_x++;
		adjust_x = width+1;
		}
	else if(adjust_x <= 1)
		{
		pos_x--;
		adjust_x = width+1;
		}
	}

